from pytest_cases import parametrize_with_cases

from pytestifyx import TestCase
from pytestifyx.utils.requests.requests_config import Config

from ..template.core import APIExample
from ..test_data.busi import BusiAPIData


class TestBusiAPISample(TestCase):
    config = Config()
    i = APIExample()

    @parametrize_with_cases('param', cases=BusiAPIData, prefix="busi_")
    def test_busi_api_case_get(self, param, **conf):
        self.config.set_attr(**conf, concurrent_number=1)
        response = self.i.httpbin_get(self.config, param)
        assert response.status_code == 200
        return response

    @parametrize_with_cases('param', cases=BusiAPIData, prefix="busi_")
    def test_busi_api_case_post(self, param, **conf):
        self.config.set_attr(**conf, concurrent_number=1, request_method='POST')
        response = self.i.httpbin_post(self.config, param)
